
const { wrap } = require('co');

const makeGeneratorFunction = require('../makeGeneratorFunction');

const pm2 = makeGeneratorFunction.pm2;

describe('makeGeneratorFunction', function () {

  it('sets pm2_home if NODE_ENV === "test"', function () {
    makeGeneratorFunction.pm2.pm2_home.should.equal('.pm2');
  });

  it('returns a result if all goes as planned', wrap(function* () {
    pm2.foo = function (cb) {
      cb(null, 'foo');
    };
    const gf = makeGeneratorFunction('foo');
    const result = yield gf();
    result.should.equal('foo');
  }));

  it('throws if the method returns an error', wrap(function* () {
    pm2.foo = function (cb) {
      cb('err');
    };
    const gf = makeGeneratorFunction('foo');
    try {
      yield gf();
      throw 'not err';
    } catch (ex) {
      ex.should.equal('err');
    }
  }));

});
