'use strict';

const { wrap } = require('co');

const makeGeneratorFunction = require('./makeGeneratorFunction');

function makeMethod(name) {
  return wrap(makeGeneratorFunction(name));
}

module.exports = {
  start: makeMethod('start'),
  stop: makeMethod('stop'),
  restart: makeMethod('restart'),
  delete: makeMethod('delete'),
  deploy: makeMethod('deploy'),
  gracefulReload: makeMethod('gracefulReload'),
  killDaemon: makeMethod('killDaemon'),
  pingDaemon: makeMethod('ping'),
  describe: makeMethod('describe'),
  list: makeMethod('list'),
  dump: makeMethod('dump'),
  flush: makeMethod('flush'),
  reloadLogs: makeMethod('reloadLogs'),
  launchBus: makeMethod('launchBus'),
  sendSignalToProcessName: makeMethod('sendSignalToProcessName'),
  resurrect: makeMethod('resurrect'),
  getProcessIdByName: makeMethod('getProcessIdByName'),
  getVersion: makeMethod('getVersion')
};
